#include "header.h"
#include "european.h"
#include "util.h"
#include <math.h>
#include <stdio.h>

/* Fill Weight[p2] with weights from (t1,p1) -> (t2,*) 
 * This is stretched out to be readable.  Variables can be 
 * eliminated and loops combined.  Includes the subterfuge.
 */
void weights1(int t1, int p1, int t2){
  int u, p2, points, ig;
  double arg[POINTS_SIZE], f[POINTS_SIZE], growth[UNDERLIERS_SIZE][POINTS_SIZE],num_det,den_det;
  static double g[POINTS_SIZE];
  static int last_t2 = -1, last_ig = -1;

  points = points_on_timeslice(t2);
  Sum_weights = 0;

  ig = generate_mask(t1,p1);

  for(p2=0;p2<points;++p2){
    arg[p2] = 0;
  }

  for(u=0;u<UNDERLIERS;++u){
    for(p2=0;p2<points;++p2){
      growth[u][p2] = log(Price[t2][u][p2]/Price[t1][u][p1]) + (double)(t2-t1)*VARIANCE/2.0;
    }
  }

  for(u=0;u<UNDERLIERS;++u){
    for(p2=0;p2<points;++p2){
      arg[p2] += Underlier_mask[u]*(growth[u][p2] - (double)(t2-t1)*(INTEREST-DIVIDEND))*(growth[u][p2] - (double)(t2-t1)*(INTEREST-DIVIDEND))/((double)(t2-t1)*VARIANCE);
    }
  }

  for(p2=0;p2<points;++p2){
    f[p2] = exp(-0.5*arg[p2]);
  }

  num_det = pow( sqrt((double)(t2-t1)*VARIANCE), UNDERLIERS-ig);

  if((t2 != last_t2) || (ig != last_ig)){
    last_t2 = t2; 
    last_ig = ig;
    
    for(p2=0;p2<points;++p2){
      arg[p2] = 0;
    }
    
    for(u=0;u<UNDERLIERS;++u){
      for(p2=0;p2<points;++p2){
	growth[u][p2] = log(Price[t2][u][p2]/Price[0][u][0]) + (t2-0)*VARIANCE/2.0;
      }
    }
    
    for(u=0;u<UNDERLIERS;++u){
      for(p2=0;p2<points;++p2){
	arg[p2] += Underlier_mask[u]*(growth[u][p2] - (t2-0)*(INTEREST-DIVIDEND))*(growth[u][p2] - (t2-0)*(INTEREST-DIVIDEND))/((t2-0)*VARIANCE);
      }
    }
    
    for(p2=0;p2<points;++p2){
      g[p2] = exp(-0.5*arg[p2]);
    }
  }

  den_det = pow( sqrt(VARIANCE), UNDERLIERS-ig);
    
  for(p2=0;p2<points;++p2){
    Weight[p2] = 1.0/sqrt(num_det)*f[p2] /(1.0/sqrt(den_det)*g[p2]);
    Sum_weights += 1.0/sqrt(num_det)*f[p2] /(1.0/sqrt(den_det)*g[p2]);
/*     printf("%lf %lf %lf \n",arg[p2],exp(-0.5*arg[p2]),g[p2]); */
  }
/*   printf("\n"); */
  if (Sum_weights ==0) printf("BUG\n");
}
